Subject: bug#52298: 29.0.50; Frequent redisplay cycles induced by c-type-finder-timer-func timer in CC Mode

From: Alan Mackenzie <[email-masked]>
Date: Fri, 10 Dec 2021 18:16:21 +0000

Hello, Eli.

On Thu, Dec 09, 2021 at 22:38:32 +0200, Eli Zaretskii wrote:
> > Date: Thu, 9 Dec 2021 20:11:32 +0000
> > Cc: [email-masked], [email-masked]
> > From: Alan Mackenzie <[email-masked]>

[ .... ]

> It seems the reason is not the 'fontified' property, it's the
> 'c-is-sws' property that c-forward-sws puts on the buffer text.  I
> show the backtrace below.  There's also the 'c-type' property that
> c-get-fontification-context puts; see the second backtrace below.

Thanks for the debugging!

> Both of these are called from the timer function.  Are they using
> with-silent-modifications?

I'm pretty sure they are.

I think that modify_text_properties is calling modiff_incr even when
inhibit_modification_hooks is non-nil.  I tried putting an `if' around
that bit of the code, without any great success.

The main reason for all the redisplaying (which I got from
trace-redisplay displaying "redisplay_preserve_echo_area (8)") is the
call from detect_input_pending_run_timers in keyboard.c.  It is calling
redisplay_preserve_echo_area each time the timer triggers.

The call to detect_input_pending_run_timers (true) (that argument being
`do_display') seems to be in dispnew.c, assuming it's not in process.c.
I'll need to look further into this.

> The result of this is that the buffer's modification tick is increased
> all the time, and redisplay_window then decides that the current glyph
> matrix is not up-to-date, which means it must work harder to decide
> how to redisplay this window.

> Here are the two backtraces I promised:

> #0  0x013118d6 in modiff_incr (a=0x6ee5310) at lisp.h:3552
> #1  0x0131203e in modify_text_properties (buffer=XIL(0xa000000006ee50a0),
>     start=make_fixnum(39237), end=make_fixnum(39238)) at textprop.c:91
> #2  0x01316a2b in add_text_properties_1 (start=make_fixnum(39237),
>     end=make_fixnum(39238), properties=XIL(0xc00000000082b538),
>     object=XIL(0xa000000006ee50a0), set_type=TEXT_PROPERTY_REPLACE,
>     destructive=true) at textprop.c:1224
> #3  0x01316ef0 in Fadd_text_properties (start=make_fixnum(39237),
>     end=make_fixnum(39238), properties=XIL(0xc00000000082b538), object=XIL(0))
>     at textprop.c:1296
> #4  0x01316fcf in Fput_text_property (start=make_fixnum(39237),
>     end=make_fixnum(39238), property=XIL(0x56056f0), value=XIL(0x30),
>     object=XIL(0)) at textprop.c:1314
> #5  0x012670c5 in funcall_subr (subr=0x17216a0 <Sput_text_property>,
>     numargs=4, args=0x82b790) at eval.c:3152

[ .... ]

> Lisp Backtrace:
> "put-text-property" (0x82b790)
> "c-forward-sws" (0x82c0a8)
> "c-fl-decl-start" (0x82c7d8)
> "c-context-expand-fl-region" (0x82cdd0)
> 0x753e6b0 PVEC_COMPILED
> "mapc" (0x82d688)
> "c-before-context-fl-expand-region" (0x82dc90)
> "c-type-finder-timer-func" (0x82e530)
> "apply" (0x82e528)
> "timer-event-handler" (0x82eba8)

> ----------------------------------------------------------------------

> #0  0x013118d6 in modiff_incr (a=0x6ee5310) at lisp.h:3552
> #1  0x0131203e in modify_text_properties (buffer=XIL(0xa000000006ee50a0),
>     start=make_fixnum(39339), end=make_fixnum(39340)) at textprop.c:91
> #2  0x01316a2b in add_text_properties_1 (start=make_fixnum(39339),
>     end=make_fixnum(39340), properties=XIL(0xc00000000082b258),
>     object=XIL(0xa000000006ee50a0), set_type=TEXT_PROPERTY_REPLACE,
>     destructive=true) at textprop.c:1224
> #3  0x01316ef0 in Fadd_text_properties (start=make_fixnum(39339),
>     end=make_fixnum(39340), properties=XIL(0xc00000000082b258), object=XIL(0))
>     at textprop.c:1296
> #4  0x01316fcf in Fput_text_property (start=make_fixnum(39339),
>     end=make_fixnum(39340), property=XIL(0x57a2ff8), value=XIL(0x566adc8),
>     object=XIL(0)) at textprop.c:1314
> #5  0x012670c5 in funcall_subr (subr=0x17216a0 <Sput_text_property>,
>     numargs=4, args=0x82b478) at eval.c:3152

[ .... ]

> Lisp Backtrace:
> "put-text-property" (0x82b478)
> "c-get-fontification-context" (0x82bc88)
> 0x7581bc8 PVEC_COMPILED
> "c-find-decl-spots" (0x82d638)
> "c-find-types-background" (0x82dc98)
> "c-type-finder-timer-func" (0x82e530)
> "apply" (0x82e528)
> "timer-event-handler" (0x82eba8)
> (gdb) fr 4
> #4  0x01316fcf in Fput_text_property (start=make_fixnum(39339),
>     end=make_fixnum(39340), property=XIL(0x57a2ff8), value=XIL(0x566adc8),
>     object=XIL(0)) at textprop.c:1314
> 1314      Fadd_text_properties (start, end, properties, object);
> (gdb) pp property
> c-type

-- 
Alan Mackenzie (Nuremberg, Germany).